use crate::error::AdventError;

pub trait AdventDayPart1 {
    fn read_input(&mut self) -> Result<(),AdventError>;
    fn solve(&mut self) -> Result<String, AdventError>;
}

pub trait AdventDayPart2 {
    fn read_input(&mut self) -> Result<(),AdventError>;
    fn solve(&mut self) -> Result<String, AdventError>;
}

pub trait AdventDay {
    fn puzzle1(&mut self) -> Result<String, AdventError>;
    fn puzzle2(&mut self) -> Result<String, AdventError>;
}

pub mod day1;
pub mod day2;
pub mod day3;
pub mod day4;
pub mod day5;
pub mod day6;
pub mod day7;
pub mod day8;
pub mod day9;
pub mod day10;
pub mod day14;

/*
use std::path::Path;

use advent_derive::advent_day;

use crate::error::AdventError;
use super::*;


struct Part1{}
struct Part2{}

impl Part1 {
    fn new() -> Self {
        Self{}
    }
}

impl Part2 {
    fn new() -> Self{
        Self{}
    }
}


fn read_input_part1(part1: &mut Part1, path: &Path) -> Result<(), AdventError> {
    Ok(())
}

fn solve_part1(part1: &mut Part1) -> Result<String, AdventError> {
    Ok("0".to_string())
}

fn read_input_part2(part2: &mut Part2, path: &Path) -> Result<(), AdventError> {
    Ok(())
}

fn solve_part2(part2: &mut Part2) -> Result<String, AdventError> {
    Ok("0".to_string())
}

#[advent_day(Part1, Part2)]
struct Day8;
*/